﻿Public Class Form1

    Private WithEvents mtimer As MilliTimer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----------------------------------------------------------------
        ToolTips_Init()
        Load_INI()
        StartThereminoHAL()
        ' ---------------------------------------------------------------- WINDOW
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        'If Form2_VisibleAtStart Then Form2.Show()
        Me.Text = AppTitleAndVersion()
        ' ----------------------------------------------------------------
        mtimer = New MilliTimer()
        mtimer.Interval = txt_PollingTime.NumericValueInteger
        mtimer.Start()
        ' ----------------------------------------------------------------
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
        If mtimer IsNot Nothing Then mtimer.Stop()
        StopThereminoHAL()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub txt_PollingTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_PollingTime.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        mtimer.Interval = txt_PollingTime.NumericValueInteger
    End Sub


    ' =========================================================================
    '   THEREMINO HAL - START STOP -
    ' =========================================================================
    Private HalProcess As Process = Nothing
    Private Sub StartThereminoHAL()
        Dim path As String = Application.StartupPath & "\Theremino_HAL.exe"
        If Not My.Computer.FileSystem.FileExists(path) Then
            path = Application.StartupPath & "\Theremino_HAL\Theremino_HAL.exe"
        End If
        If Not My.Computer.FileSystem.FileExists(path) Then Return
        Dim psi As New ProcessStartInfo
        psi.WorkingDirectory = IO.Path.GetDirectoryName(path)
        psi.FileName = path
        HalProcess = Process.Start(psi)
    End Sub
    Private Sub StopThereminoHAL()
        If HalProcess IsNot Nothing AndAlso Not HalProcess.HasExited Then
            Try
                HalProcess.CloseMainWindow()
            Finally
            End Try
        End If
    End Sub

    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.FromArgb(230, 230, 230), _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub


    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class


    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub



    ' =======================================================================================
    '   MENU TOOLS
    ' =======================================================================================
    Private Sub Menu_Tools_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Tools.DropDownOpening
        If Form2.Visible Then
            Menu_Tools_ShowAnalogGauge.Checked = True
        Else
            Menu_Tools_ShowAnalogGauge.Checked = False
        End If
    End Sub
    Private Sub Menu_Tools_ShowAnalogGauge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_ShowAnalogGauge.Click
        If Form2.Visible Then
            Form2.Visible = False
        Else
            Form2.Visible = True
        End If
    End Sub

    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_File_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        Me.Close()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("ProgramHelp", ".pdf")
    End Sub
    Private Sub Menu_Help_RadioactiveSamples_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Help_RadioactiveSamples.Click
        OpenLocalizedHelp("RadioactiveSamples")
    End Sub
    Private Sub Menu_Help_RadiationScales_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_RadiationScales.Click
        OpenLocalizedHelp("RadiationScales")
    End Sub
    Private Sub Menu_Help_AmbientalRadiation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_AmbientalRadiation.Click
        OpenLocalizedHelp("AmbientalRadiation")
    End Sub
    Private Sub Menu_Help_Isotopes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Isotopes.Click
        OpenLocalizedHelp("Isotopes")
    End Sub
    Private Sub Menu_Help_Procedures_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Procedures.Click
        OpenLocalizedHelp("Procedures")
    End Sub

    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
        Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
            If FileExists(fname) Then
                Process.Start(fname)
            End If
        End If
    End Sub

    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub


    ' ====================================================================================================
    '  ToolStrip buttons
    ' ====================================================================================================
    Private Sub ToolStripButton_OpenPSN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_Open.Click
        OpenPsnDialog()
    End Sub
    Private Sub ToolStripButton_SavePSN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SavePSN.Click
        SavePSN("Test")
    End Sub
    Private Sub ToolStripButton_OpenHelicord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_OpenHelicord.Click
        If Form2.WindowState = FormWindowState.Minimized Then Form2.WindowState = 0
        Form2.Show()
    End Sub


    ' ====================================================================================================
    '  MilliTimerElapsed_ThreadSafe
    ' ====================================================================================================
    Private Sub MilliTimerElapsed_ThreadSafe() Handles mtimer.MilliTimerElapsed
        Me.Invoke(New MilliTimerElapsed_Delegate(AddressOf MilliTimerElapsed))
    End Sub
    Private Delegate Sub MilliTimerElapsed_Delegate()
    Private Sub MilliTimerElapsed()
        PollSlots()
        'TestTime()
    End Sub
    Private Sub TestTime()
        Static t As Double = 0
        t = t + mtimer.Interval
        If t >= 1000 Then
            t = 0
            Beep()
            Me.Text = DateTime.Now.Millisecond.ToString
        End If
    End Sub

    ' ===========================================================================================================
    '   UPDATES
    ' ===========================================================================================================
    Private Sub PollSlots()
        Dim slot As Int32

        ' -----------------------------------------------------------
        slot = txt_FirstInputSlot.NumericValueInteger
        If slot >= 0 Then
            For i As Int32 = 0 To txt_NumInputSlots.NumericValueInteger - 1
                NewValue(Slots.ReadSlot_NoNan(slot))
                slot += 1
            Next
        End If
    End Sub


    Private zeroValue As Single = 487

    Private Sub NewValue(ByVal vnew As Single)
        ' ------------------------------------------------- hi pass 0.1 Hz
        vnew = vnew - zeroValue
        zeroValue += vnew * 0.001F

        ' ------------------------------------------------- FIR 100
        vnew = 10 * FIR_100(vnew)

        ' ------------------------------------------------- IIR 100
        vnew = IIR(vnew, 100)

        Slots.WriteSlot(400, vnew + 500)
    End Sub


    'Private Sub NewValue(ByVal vnew As Single)

    '    ' ------------------------------------------------- FIR 100
    '    vnew = 10 * FIR_100(vnew)

    '    ' ------------------------------------------------- IIR 1000
    '    vnew = IIR_1000(vnew, 1000)

    '    ' ------------------------------------------------- hi pass 0.1 Hz
    '    vnew = vnew - zeroValue
    '    zeroValue += vnew * 0.001F


    '    WriteSlot(400, vnew + 500)

    'End Sub

    Private Function IIR(ByVal vnew As Single, ByVal div As Single) As Single
        Static v As Single
        v += (vnew - v) / div
        Return v
    End Function

    Private Function FIR_100(ByVal nextV As Single) As Single
        Static xv(100) As Single
        Dim sum As Single = 0
        xv(100) = nextV
        For i As Int32 = 0 To 99
            xv(i) = xv(i + 1)
            sum += xv(i)
        Next
        Return sum
    End Function



    ' ===========================================================================================================
    '   BUTTONS
    ' ===========================================================================================================
    Private Sub btn_Recognize_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs)

    End Sub
    Private Sub btn_Calibrate_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs)
        If Not EventsAreEnabled Then Exit Sub

    End Sub
    Private Sub btn_Validate_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Validate.ClickButtonArea
        If Not EventsAreEnabled Then Exit Sub

    End Sub
    Private Sub btn_ShowDetails_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs)
        Form2.Show()
    End Sub



    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    'Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
    '    OpenLocalizedHelp("ProgramHelp", ".pdf")
    'End Sub
    'Private Sub Menu_Help_RadioactiveSamples_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Help_RadioactiveSamples.Click
    '    OpenLocalizedHelp("RadioactiveSamples")
    'End Sub
    'Private Sub Menu_Help_RadiationScales_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_RadiationScales.Click
    '    OpenLocalizedHelp("RadiationScales")
    'End Sub
    'Private Sub Menu_Help_AmbientalRadiation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_AmbientalRadiation.Click
    '    OpenLocalizedHelp("AmbientalRadiation")
    'End Sub
    'Private Sub Menu_Help_Isotopes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Isotopes.Click
    '    OpenLocalizedHelp("Isotopes")
    'End Sub
    'Private Sub Menu_Help_Procedures_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Procedures.Click
    '    OpenLocalizedHelp("Procedures")
    'End Sub

    'Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
    '    Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_" & Strings.Left(Language, 3).ToUpper & ext)
    '    If FileExists(fname) Then
    '        Process.Start(fname)
    '    Else
    '        fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
    '        If FileExists(fname) Then
    '            Process.Start(fname)
    '        Else
    '            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
    '            If FileExists(fname) Then
    '                Process.Start(fname)
    '            End If
    '        End If
    '    End If
    'End Sub


    ' ==================================================================================================
    '   DIALOG OPEN PSN
    ' ==================================================================================================
    Private PSN_File As String = ""

    Private Sub OpenPsnDialog()
        '
        PSN_File = PlatformAdjustedFileName(PSN_File, Application.StartupPath & "/../DataFiles/")
        '
        Dim ofd As OpenFileDialog = New OpenFileDialog
        If IO.File.Exists(PSN_File) Then
            ofd.InitialDirectory = IO.Path.GetDirectoryName(PSN_File)
            ofd.FileName = PSN_File
        Else
            ofd.InitialDirectory = PlatformAdjustedFileName(Application.StartupPath & "\..\DataFiles")
            ofd.FileName = ""
        End If
        PSN_File = PlatformAdjustedFileName(PSN_File)
        ofd.ShowDialog()
        PSN_File = ofd.FileName
        PSN_Load(IO.Path.GetFileName(PSN_File))
        Save_INI()
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_CommSpeed, _
                        "Communication speed" & vbCrLf & _
                        "- - - - - - - - - - - - - - -" & vbCrLf & _
                        "  1  =     1  Kilo-Baud" & vbCrLf & _
                        "  2  =     2  Kilo-Baud" & vbCrLf & _
                        "  3  =     5  Kilo-Baud" & vbCrLf & _
                        "  4  =   10  Kilo-Baud" & vbCrLf & _
                        "  5  =   20  Kilo-Baud" & vbCrLf & _
                        "  6  =   50  Kilo-Baud" & vbCrLf & _
                        "  7  = 100  Kilo-Baud" & vbCrLf & _
                        "  8  = 200  Kilo-Baud" & vbCrLf & _
                        "  9  = 500  Kilo-Baud" & vbCrLf & _
                        "10  =  1  Mega-Baud" & vbCrLf & _
                        "11  =  2  Mega-Baud" & vbCrLf & _
                        "12  =  4  Mega-Baud")

        'ttp1.SetToolTip(txt_MinChange, _
        '                "Sensitivity to movements" & vbCrLf & _
        '                " - - - - - - - - - - - - - - - - -" & vbCrLf & _
        '                " 100 = large movements" & vbCrLf & _
        '                "   30 = normal" & vbCrLf & _
        '                "   10 = little movements")

        'ttp1.SetToolTip(txt_CapArea, _
        '                "Approximate area of the sensor." & vbCrLf & _
        '                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
        '                " The linearity between zones ""Away"" and ""Close"" can be altered" & vbCrLf & _
        '                " setting a value-area more or less than the real one." & vbCrLf & _
        '                " A greater value compresses the area more distant from the sensor." & vbCrLf & _
        '                " A smaller value expands the area most distant from the sensor.")
    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub txt_Min_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_CommSpeed.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


End Class


