﻿Imports System.Drawing.Drawing2D
Imports System.Globalization

Public Class Form2

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        'Me.Show()
        'ShowHelicordBackground(pbox_Helicord)
    End Sub

    Private Sub Form2_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged, _
                                                                                                    Me.SizeChanged
        If Not EventsAreEnabled Then Exit Sub
        If WindowState = FormWindowState.Minimized Then Return
        ShowHelicordBackground(pbox_Helicord)
    End Sub


    Private Sub Form2_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
 
    End Sub

    Private Sub Form2_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        If Not EventsAreEnabled Then Exit Sub
        If WindowState = FormWindowState.Minimized Then Return
        ShowHelicordBackground(pbox_Helicord)
    End Sub

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Me.Hide()
        e.Cancel = True
    End Sub

    Private Sub Form2_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub ShowHelicordBackground(ByVal pbox As PictureBox)

        Dim StationString As String = "MQZ/10-HHZ/NZ"
        Dim TitleString As String = "McQueen's Valley"
        Dim TimeZoneCode As String = "NZST"
        Dim CreditsString As String = "Theremino Geo"
        Dim BackColor As Color = Color.White
        Dim TextColor As Color = Color.MidnightBlue 'Color.FromArgb(28, 26, 116)
        Dim NumbersColor As Color = Color.Black

        Dim nHor As Int32 = 36
        Dim nVert As Int32 = 6

        Dim PboxW As Int32 = pbox.ClientSize.Width
        Dim PboxH As Int32 = pbox.ClientSize.Height

        ' ------------------------------------------------ using a bitmap for best performance
        If pbox.Image Is Nothing OrElse pbox.Width <> pbox.Image.Width OrElse pbox.Height <> pbox.Image.Height Then
            InitPictureboxImage(pbox)
        End If
        ' ------------------------------------------------ using "Graphics.FromImage" for best performance
        Dim g As Graphics = Graphics.FromImage(pbox.Image)

        g.Clear(BackColor)
        g.TextContrast = 4

        Dim fontSize As Single = (PboxH \ nHor) * 0.8F
        If fontSize > 14 Then fontSize = 14
        If fontSize < 8 Then fontSize = 8

        Dim px1 As Single = fontSize * 4.0F
        Dim px2 As Single = PboxW - fontSize * 2.0F

        Dim py1 As Single = fontSize * 2.5F
        Dim py2 As Single = PboxH - fontSize * 2.5F

        Dim str As String
        Dim s As SizeF
        '
        ' ------------------------------------------------ horiz-lines
        Dim b As SolidBrush
        b = New SolidBrush(NumbersColor)
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
        Dim f As Font = New Font("Arial", fontSize, FontStyle.Regular, GraphicsUnit.Pixel, 0, False)
        For i As Int32 = 0 To nHor - 1
            Dim y As Single = py1 + CSng(i + 1) / (nHor + 1) * (py2 - py1)
            g.DrawLine(Pens.LightGray, px1 - fontSize * 0.5F, y, px2, y)
            Dim t As String = TimeOfDay.AddHours(i).ToUniversalTime.ToString("HH:MM").Replace(".", ":")
            g.DrawString(t, f, b, 5, y - fontSize * 0.5F - 1)
        Next
        '
        ' ------------------------------------------------ vertical-lines
        Dim p As Pen = New Pen(Color.Gray)
        p.Width = 1
        p.DashCap = DashCap.Round
        p.DashStyle = DashStyle.Dot
        p.DashPattern = New Single() {1, 2}
        For i As Int32 = 0 To nVert - 1
            Dim x As Single = px1 + CSng(i) / nVert * (px2 - px1)
            g.DrawLine(p, x, py1, x, py2)
            str = ((i + 1) * 10).ToString()
            x = px1 + CSng(i + 1) / nVert * (px2 - px1)
            g.DrawString(str, f, b, x - fontSize * 0.8F, py2 + fontSize * 0.2F)
        Next
        '
        ' ------------------------------------------------ scale border
        g.DrawRectangle(Pens.Gray, px1, py1, _
                        px2 - px1, py2 - py1)
        '
        ' ------------------------------------------------ station
        b = New SolidBrush(TextColor)
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.ClearTypeGridFit
        f = New Font("Arial", fontSize * 1.5F, FontStyle.Bold Or FontStyle.Italic, GraphicsUnit.Pixel)
        g.DrawString(StationString, f, b, px1, fontSize * 0.3F)
        ' ------------------------------------------------ title
        f = New Font("Arial", fontSize * 1.5F, FontStyle.Bold Or FontStyle.Italic, GraphicsUnit.Pixel)
        s = g.MeasureString(TitleString, f)
        g.DrawString(TitleString, f, b, PboxW \ 2 - s.Width / 2, fontSize * 0.3F)
        '
        ' ------------------------------------------------ LOCAL TIME
        f = New Font("Arial", fontSize * 1.3F, FontStyle.Bold Or FontStyle.Italic, GraphicsUnit.Pixel)
        str = Date.Now.ToString("yyyy/MM/dd  hh:mm:ss  " & TimeZoneCode).Replace(".", ":")
        s = g.MeasureString(str, f)
        g.DrawString(str, f, b, px2 - s.Width, fontSize * 0.5F - 1)
        '
        ' ------------------------------------------------ UTC
        f = New Font("Arial", fontSize * 1.2F, FontStyle.Bold, GraphicsUnit.Pixel)
        str = "UTC " & Date.Now.ToUniversalTime.ToString("yyyy/MM/dd")
        g.DrawString(str, f, b, fontSize * 0.3F, py2 + fontSize * 0.5F - 1)
        '
        ' ------------------------------------------------ CREDITS
        b = New SolidBrush(Color.Gray)
        Dim sf As StringFormat = New StringFormat
        sf.FormatFlags = StringFormatFlags.DirectionVertical
        f = New Font("Arial", fontSize * 1.1F, FontStyle.Bold, GraphicsUnit.Pixel)
        g.DrawString(CreditsString, f, b, px2 + fontSize * 0.1F, py1, sf)
        '
        ' ------------------------------------------------ minutes
        b = New SolidBrush(Color.Gray)
        f = New Font("Arial", fontSize * 1.0F, FontStyle.Bold, GraphicsUnit.Pixel)
        g.DrawString("minutes", f, b, px2 - fontSize * 6.0F, py2 + fontSize * 0.6F - 1)

    End Sub







End Class