﻿
Module Crc

    Private CrcTable() As UInt16 = _
        {&H0, &H1021, &H2042, &H3063, &H4084, &H50A5, &H60C6, &H70E7, _
         &H8108, &H9129, &HA14A, &HB16B, &HC18C, &HD1AD, &HE1CE, &HF1EF, _
         &H1231, &H210, &H3273, &H2252, &H52B5, &H4294, &H72F7, &H62D6, _
         &H9339, &H8318, &HB37B, &HA35A, &HD3BD, &HC39C, &HF3FF, &HE3DE, _
         &H2462, &H3443, &H420, &H1401, &H64E6, &H74C7, &H44A4, &H5485, _
         &HA56A, &HB54B, &H8528, &H9509, &HE5EE, &HF5CF, &HC5AC, &HD58D, _
         &H3653, &H2672, &H1611, &H630, &H76D7, &H66F6, &H5695, &H46B4, _
         &HB75B, &HA77A, &H9719, &H8738, &HF7DF, &HE7FE, &HD79D, &HC7BC, _
         &H48C4, &H58E5, &H6886, &H78A7, &H840, &H1861, &H2802, &H3823, _
         &HC9CC, &HD9ED, &HE98E, &HF9AF, &H8948, &H9969, &HA90A, &HB92B, _
         &H5AF5, &H4AD4, &H7AB7, &H6A96, &H1A71, &HA50, &H3A33, &H2A12, _
         &HDBFD, &HCBDC, &HFBBF, &HEB9E, &H9B79, &H8B58, &HBB3B, &HAB1A, _
         &H6CA6, &H7C87, &H4CE4, &H5CC5, &H2C22, &H3C03, &HC60, &H1C41, _
         &HEDAE, &HFD8F, &HCDEC, &HDDCD, &HAD2A, &HBD0B, &H8D68, &H9D49, _
         &H7E97, &H6EB6, &H5ED5, &H4EF4, &H3E13, &H2E32, &H1E51, &HE70, _
         &HFF9F, &HEFBE, &HDFDD, &HCFFC, &HBF1B, &HAF3A, &H9F59, &H8F78, _
         &H9188, &H81A9, &HB1CA, &HA1EB, &HD10C, &HC12D, &HF14E, &HE16F, _
         &H1080, &HA1, &H30C2, &H20E3, &H5004, &H4025, &H7046, &H6067, _
         &H83B9, &H9398, &HA3FB, &HB3DA, &HC33D, &HD31C, &HE37F, &HF35E, _
         &H2B1, &H1290, &H22F3, &H32D2, &H4235, &H5214, &H6277, &H7256, _
         &HB5EA, &HA5CB, &H95A8, &H8589, &HF56E, &HE54F, &HD52C, &HC50D, _
         &H34E2, &H24C3, &H14A0, &H481, &H7466, &H6447, &H5424, &H4405, _
         &HA7DB, &HB7FA, &H8799, &H97B8, &HE75F, &HF77E, &HC71D, &HD73C, _
         &H26D3, &H36F2, &H691, &H16B0, &H6657, &H7676, &H4615, &H5634, _
         &HD94C, &HC96D, &HF90E, &HE92F, &H99C8, &H89E9, &HB98A, &HA9AB, _
         &H5844, &H4865, &H7806, &H6827, &H18C0, &H8E1, &H3882, &H28A3, _
         &HCB7D, &HDB5C, &HEB3F, &HFB1E, &H8BF9, &H9BD8, &HABBB, &HBB9A, _
         &H4A75, &H5A54, &H6A37, &H7A16, &HAF1, &H1AD0, &H2AB3, &H3A92, _
         &HFD2E, &HED0F, &HDD6C, &HCD4D, &HBDAA, &HAD8B, &H9DE8, &H8DC9, _
         &H7C26, &H6C07, &H5C64, &H4C45, &H3CA2, &H2C83, &H1CE0, &HCC1, _
         &HEF1F, &HFF3E, &HCF5D, &HDF7C, &HAF9B, &HBFBA, &H8FD9, &H9FF8, _
         &H6E17, &H7E36, &H4E55, &H5E74, &H2E93, &H3EB2, &HED1, &H1EF0}


    Private CRC16 As UInt16

    Friend Sub CRC16_Init(Optional ByVal InitialCrc As UInt16 = 0)
        CRC16 = InitialCrc
    End Sub

    Friend Sub CRC16_Add_ByteArray(ByVal ByteArray As Byte())
        For Each b As Byte In ByteArray
            CRC16 = CRC16 << 8 Xor CrcTable(CRC16 >> 8 Xor b)
        Next
    End Sub

    Friend Sub CRC16_Add_Byte(ByVal b As Byte)
        CRC16 = CRC16 << 8 Xor CrcTable(CRC16 >> 8 Xor b)
    End Sub

    Friend Sub CRC16_Add_Int32(ByVal IntNumber As Int32)
        Dim bytearray As Byte() = BitConverter.GetBytes(IntNumber)
        For Each b As Byte In bytearray
            CRC16 = CRC16 << 8 Xor CrcTable(CRC16 >> 8 Xor b)
        Next
    End Sub

    Friend Sub CRC16_Add_Int16_Array(ByVal Int16Array As Int16())
        For Each i As Int16 In Int16Array
            CRC16_Add_ByteArray(BitConverter.GetBytes(i))
        Next
    End Sub

    Friend Sub CRC16_Add_Int32_Array(ByVal Int32Array As Int32())
        For Each i As Int32 In Int32Array
            CRC16_Add_ByteArray(BitConverter.GetBytes(i))
        Next
    End Sub

    Friend Sub CRC16_Add_Single_Array(ByVal SingleArray As Single())
        For Each s As Single In SingleArray
            CRC16_Add_ByteArray(BitConverter.GetBytes(s))
        Next
    End Sub

    Friend Sub CRC16_Add_Double_Array(ByVal DoubleArray As Double())
        For Each d As Double In DoubleArray
            CRC16_Add_ByteArray(BitConverter.GetBytes(d))
        Next
    End Sub

    Friend Function CRC16_GetCrc() As UInt16
        Return CRC16
    End Function

End Module

