﻿
Friend Class FIFO_INT

    Private FifoMaxLength As Int32

    Private FifoBuffer() As Int32
    Private WriteIndex As Int32

    Friend Sub New(ByVal length As Int32)
        FifoMaxLength = length
        ReDim FifoBuffer(FifoMaxLength - 1)
    End Sub

    Friend Sub Init(ByVal value As Single)
        FillWith(0)
        WriteIndex = 0
    End Sub

    Private Sub FillWith(ByVal value As Single)
        Dim sum As Single = 0
        For j As Int32 = 0 To FifoBuffer.Length - 1
            sum += value
            If sum > 1 Then
                FifoBuffer(j) = 1
                sum -= 1
            Else
                FifoBuffer(j) = 0
            End If
        Next
    End Sub

    Friend Sub AddValue(ByVal value As Int32)
        FifoBuffer(WriteIndex) = value
        WriteIndex += 1
        If WriteIndex >= FifoMaxLength Then WriteIndex = 0
    End Sub

    Friend Function GetSum(ByVal seconds As Int32) As Int32
        If seconds < 1 Then seconds = 1
        If seconds > FifoMaxLength Then seconds = FifoMaxLength
        Dim sum As Int32 = 0
        Dim w As Int32 = WriteIndex
        For i As Int32 = 0 To seconds - 1
            If w <= 0 Then
                w = FifoMaxLength - 1
            Else
                w -= 1
            End If
            sum += FifoBuffer(w)
        Next
        Return sum
    End Function

End Class
