﻿
Imports System.Math

Module Module_Utils

    Friend Sub InitPictureboxImage(ByVal pbox As PictureBox)
        With pbox
            If .ClientSize.Width < 1 Then Return
            .Image = New Bitmap(.ClientSize.Width, .ClientSize.Height)
        End With
    End Sub

    ' ==============================================================================================================
    '   COMBO FUNCTIONS
    ' ==============================================================================================================
    Friend Sub Combo_Init(ByVal combo As ComboBox, ByVal str As String)
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If str = Nothing Then str = ""
        With combo
            .Items.Clear()
            .Items.Add(str)
            .SelectedIndex = 0
        End With
        EventsAreEnabled = old
    End Sub
    Friend Sub Combo_SetIndex_FromString(ByVal combo As ComboBox, ByVal str As String)
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If str = Nothing Then str = ""
        With combo
            For i As Int32 = 0 To .Items.Count - 1
                If .Items(i).ToString = str Then
                    .SelectedIndex = i
                    Exit For
                End If
            Next
        End With
        EventsAreEnabled = old
    End Sub
    Friend Function Combo_GetValue(ByVal combo As ComboBox) As String
        If combo.SelectedIndex < 0 Then Return ""
        Return combo.Items(combo.SelectedIndex).ToString()
    End Function
    Friend Sub Combo_SetIndex(ByVal combo As ComboBox, ByVal index As Int32)
        If combo.Items.Count < 1 Then Exit Sub
        If index < 0 Then index = 0
        If index > combo.Items.Count - 1 Then index = combo.Items.Count - 1
        combo.SelectedIndex = index
    End Sub


    ' =============================================================================================
    '  ASYNC MOUSE KEYS and MOUSE STATE
    ' =============================================================================================
    Friend Function LeftMousePressed() As Boolean
        Return (Control.MouseButtons And Windows.Forms.MouseButtons.Left) <> Windows.Forms.MouseButtons.None
    End Function



    ' =============================================================================================
    '  ByteArrays 
    ' =============================================================================================
    Friend Function ByteArrayFromUint16(ByVal n As UInt16) As Byte()
        Dim b(1) As Byte
        b(0) = CByte(n \ 256)
        b(1) = CByte(n Mod 256)
        Return b
    End Function
    Friend Function ByteArray_From_Uint16Array(ByVal n() As UInt16) As Byte()
        Dim b(n.Length * 2 - 1) As Byte
        For i As Int32 = 0 To n.Length - 1
            b(i * 2) = CByte(n(i) \ 256)
            b(i * 2 + 1) = CByte(n(i) Mod 256)
        Next
        Return b
    End Function

End Module



