﻿Module Utils_Files


    Friend WaveFileNames As Collections.ObjectModel.ReadOnlyCollection(Of String)

    Friend Sub ReadWaveFileNames()
        Try
            Dim wildcards() As String = {"*.wav"}
            Dim s As String
            s = PlatformAdjustedFileName(Application.StartupPath & "\..\Media\")
            WaveFileNames = My.Computer.FileSystem.GetFiles(s, FileIO.SearchOption.SearchTopLevelOnly, wildcards)
        Catch
        End Try
    End Sub


    'Public Function GetName(ByVal str As String) As String
    '    On Error Resume Next
    '    Return IO.Path.GetFileName(str)
    'End Function

    'Public Function GetNameWithoutExtension(ByVal str As String) As String
    '    On Error Resume Next
    '    Return IO.Path.GetFileNameWithoutExtension(str)
    '    'Return My.Computer.FileSystem.GetName(str)
    'End Function


    ' estensione minuscola e con punto iniziale
    Public Function GetExtension(ByVal str As String) As String
        On Error Resume Next
        Return LCase(IO.Path.GetExtension(str))
    End Function

    Public Function RemoveExtension(ByVal str As String) As String
        On Error Resume Next
        Return PlatformAdjustedFileName(IO.Path.GetDirectoryName(str) & "\" & IO.Path.GetFileNameWithoutExtension(str))
    End Function

    Public Function ValidFilename(ByVal s As String) As String
        s = s.Replace("/", "_")
        s = s.Replace("\", "_")
        s = s.Replace(":", "_")
        s = s.Replace("*", "_")
        s = s.Replace("?", "_")
        s = s.Replace("""", "_")
        s = s.Replace("<", "_")
        s = s.Replace(">", "_")
        s = s.Replace("|", "_")
        s = s.Replace("@", "_")
        Return s
    End Function



    Public Function FileExists(ByVal fileName As String) As Boolean
        Return My.Computer.FileSystem.FileExists(fileName)
    End Function

    Public Function FolderExists(ByVal FolderName As String) As Boolean
        If FolderName.Length < 2 Then Return False
        FolderName = LCase(FolderName)
        Select Case FolderName
            Case "a:\", "b:\", "c:\", "d:\", "e:\", "f:\", "g:\", "h:\", "i:\", "j:\", "k:\"
                Return True
        End Select
        Return My.Computer.FileSystem.DirectoryExists(FolderName)
    End Function

    Public Function GetPath(ByVal str As String) As String
        Try
            Return PlatformAdjustedFileName(IO.Path.GetDirectoryName(str) & "\")
        Catch
            Return str
        End Try
    End Function


    Public Function GetParentFolder(ByVal folder As String) As String
        Dim i As Int32
        If Right(folder, 1) = "\" Then folder = Left(folder, Len(folder) - 1)
        i = InStrRev(folder, "\")
        If i > 1 Then
            folder = Left(folder, i)
        Else
            folder = ""
        End If
        GetParentFolder = folder
    End Function

End Module
